﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace CarouselProblem
{
    public class ViewModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged = delegate { };

        private int _orderIndex;
        public int OrderIndex
        {
            get { return _orderIndex; }
            set
            {
                PropertyChanged(this, new PropertyChangedEventArgs("OrderIndex"));
                _orderIndex = value;
            }
        }

        private OrderViewModel _activeOrderViewModel;
        public OrderViewModel ActiveOrderViewModel
        {
            get { return _activeOrderViewModel; }
            set
            {
                if (_activeOrderViewModel == value) return;
                _activeOrderViewModel = value;
                PropertyChanged(this, new PropertyChangedEventArgs("ActiveOrderViewModel"));
            }
        }

        private ObservableCollection<OrderViewModel> _orderViewModels = new ObservableCollection<OrderViewModel>();
        public ObservableCollection<OrderViewModel> OrderViewModels
        {
            get { return _orderViewModels; }
            private set
            {
                if (_orderViewModels == value) return;
                _orderViewModels = value;
                PropertyChanged(this, new PropertyChangedEventArgs("OrderViewModels"));
            }
        }

        protected void OnPropertyChanged(string name)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(name));
            }
        }
    }
}
